/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * BPConst.H
 *
 * PROGRAMMER : Juan M. Alvarado
 *    VERSION : 00.000
 *    CREATED : 02/26/90
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		BrushPak contant defines for use in Brushpak source files.
 *
 * HISTORY
*/

#ifndef ECHIDNA_BPCONST_H
#define ECHIDNA_BPCONST_H

/* #include <echidna/platform.h> */
#define __MSDOS__	1

/**************************** C O N S T A N T S ***************************/
#if __MSDOS__
#define NUM_SYSTEM_COLORS			255
#elif __AMIGAOS__
#define NUM_SYSTEM_COLORS			32
#else
#error Need to define NUM_SYSTEM_COLORS for this system
#endif

#define CGA_LI_GREEN_RED_YELLOW		0
#define CGA_LI_CYAN_VIOLET_WHITE	1
#define CGA_LI_CYAN_RED_WHITE		2
#define CGA_HI_GREEN_RED_YELLOW		3
#define CGA_HI_CYAN_VIOLET_WHITE	4
#define CGA_HI_CYAN_RED_WHITE		5

#define CGA_GREEN_RED_BROWN			0
#define CGA_CYAN_VIOLET_GRAY		1
#define CGA_CYAN_RED_GRAY			2

#define CGA_LI_BLACK	0
#define CGA_LI_BLUE		1
#define CGA_LI_GREEN	2
#define CGA_LI_CYAN		3
#define CGA_LI_RED		4
#define CGA_LI_VIOLET	5	
#define CGA_LI_YELLOW	6
#define CGA_LI_WHITE	7

#define CGA_HI_BLACK	8
#define CGA_HI_BLUE		9
#define CGA_HI_GREEN	10
#define CGA_HI_CYAN		11
#define CGA_HI_RED		12
#define CGA_HI_VIOLET	13
#define CGA_HI_YELLOW	14
#define CGA_HI_WHITE	15

#define CGA_BLACK		CGA_LI_BLACK	
#define CGA_BLUE		CGA_LI_BLUE		
#define CGA_GREEN		CGA_LI_GREEN	
#define CGA_CYAN		CGA_LI_CYAN		
#define CGA_RED			CGA_LI_RED		
#define CGA_VIOLET		CGA_LI_VIOLET	
#define CGA_BROWN		CGA_LI_YELLOW
#define CGA_YELLOW		CGA_HI_YELLOW
#define	CGA_DKGRAY		CGA_HI_BLACK
#define CGA_LTGRAY		CGA_LI_WHITE
#define CGA_WHITE		CGA_HI_WHITE	

#define CGA_LI_GRAY		CGA_HI_BLACK
#define CGA_HI_GRAY		CGA_LI_WHITE


/* Positional Copies Constants */
#define PCC_ONE_COPY	pcc (0)
#define PCC_TWO_COPIES	pcc (1)
#define PCC_FOUR_COPIES	pcc (3)

/* BrushPak Type Constants */
#define BRUSH_TYPE		0
#define MASK_TYPE		1
#define VMASK_TYPE		2
#define BYTEMASK_TYPE	3
#define PREMADE_TYPE	4
#define PAINTBOX_TYPE	5
#define PALETTE_TYPE	6
#define COLORCYCLE_TYPE	7

/* PaintBox Flags Constants */
#define PAL_AND_CYCLING		0
#define PAL_ONLY			1
#define CYCLING_ONLY		2

/* Backward compatability macros */
#define indir		dir

#endif /* ECHIDNA_BPCONST_H */

