/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * BRUSHSUP.h
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 12/20/89
 *   MODIFIED : 07/26/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Public info for BRUSHPAK support routines.
 *
 * HISTORY
 *
*/
#ifndef BRUSHSUP_H
#define BRUSHSUP_H

#include <echidna/etypes.h>
#include <echidna/graphics.h>

#ifdef __cplusplus
extern "C" {
#endif

/**************************** C O N S T A N T S ***************************/

/******************************** T Y P E S *******************************/

typedef struct {
#if __MSDOS__
	PatmapTableType		 GlobalPattern;
#endif
	PaletteType			 Palette;		
	PaintBoxType		 *PaintBox;
	UWORD			 	 NumShapes;
	ULONG				*AttribTable;
	GShape				**Shapes;
} BPIType;

/****************************** G L O B A L S *****************************/

/******************************* M A C R O S ******************************/

/****************** F U N C T I O N   P R O T O T Y P E S *****************/
#if __NOT_ANSI__		/** Non-ANSI Prototypes **/


#else					/** ANSI Prototypes **/

extern BPIType		*LoadBPI (
							char		*filename,
							short			 fpfindex
							);

extern void			 RelavateBPI (BPIType *bpi, short mode);

extern void			 FreeBPI (
							BPIType	*bpi
							);

#endif /** Function Prototypes **/

#ifdef __cplusplus
}
#endif

#endif /* BRUSHSUP_H */

