/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * CHECKGLU.H
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 11/03/93
 *   MODIFIED : 10/02/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		
 *
 * HISTORY
 *
*/

#ifndef CHECKGLU_H
#define CHECKGLU_H

#include <echidna/platform.h>
#include "switches.h"
#include <echidna/proc.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <echidna/eio.h>
#include <echidna/listfunc.h>
#include <echidna/xtramem.h>
#include <echidna/memory.h>

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/

#define CHK_ReadOpen(name)		CHK_Open((name), O_RDONLY | O_BINARY)
#define CHK_OpenRead(name)		CHK_Open((name), O_RDONLY | O_BINARY)
#define CHK_WriteOpen(name)		CHK_Open((name), O_WRONLY | O_BINARY | O_TRUNC | O_CREAT)
#define CHK_OpenWrite(name)		CHK_Open((name), O_WRONLY | O_BINARY | O_TRUNC | O_CREAT)
#define CHK_UpdateOpen(name)	CHK_Open((name), O_RDWR | O_BINARY | O_CREAT)
#define CHK_OpenUpdate(name)	CHK_Open((name), O_RDWR | O_BINARY | O_CREAT)
#define CHK_AppendOpen(name)	CHK_Open((name), O_RDWR | O_BINARY | O_CREAT | O_APPEND)
#define CHK_OpenAppend(name)	CHK_Open((name), O_RDWR | O_BINARY | O_CREAT | O_APPEND)

#define	CHK_DeleteNode(ptr,id)	DeleteNode(ptr)

/****************** F U N C T I O N   P R O T O T Y P E S *****************/

PROC_GLOBAL (int , CHK_Open, (char *name, int access));
PROC_GLOBAL (long , CHK_Read, (int fh, void *buf, long size));
PROC_GLOBAL (long , CHK_Write, (int fh, void *buf, long size));
PROC_GLOBAL (void , CHK_Close, (int fh));
PROC_GLOBAL (long , CHK_Seek, (int fh, long off, int orig));
PROC_GLOBAL (long , CHK_Tell, (int fh));
PROC_GLOBAL (long , CHK_FileLength, (int fh));
PROC_GLOBAL (void , CHK_FindFile, (char *filename, char *guidename, char *pathbuff));

PROC_GLOBAL (FILE *, CHK_fopen, (char *filename, char *mode));
PROC_GLOBAL (void , CHK_fclose, (FILE *fp));
PROC_GLOBAL (size_t , CHK_fread, (void *buf, size_t size, size_t n, FILE *fp));
PROC_GLOBAL (size_t , CHK_fwrite, (void *buf, size_t size, size_t n, FILE *fp));
PROC_GLOBAL (int , CHK_fprintf, (FILE *fp, char *fmt, ...));
PROC_GLOBAL (void , CHK_fputc, (int c, FILE *fp));
PROC_GLOBAL (void , CHK_fputs, (FILE *fp, char *s));

PROC_GLOBAL (ListType *, CHK_CreateList, (char *name, char *id));
PROC_GLOBAL (void *, CHK_CreateNode, (size_t size, char *name, char *id));

PROC_GLOBAL (void *, CHK_AllocateMemory, (long size, char *id));
PROC_GLOBAL (void *, CHK_CallocateMemory, (long size, char *id));
PROC_GLOBAL (void , CHK_DeallocateMemory, (void *ptr, char *id));
PROC_GLOBAL (XTRAPntr , CHK_AllocateXTRA, (size_t size, char *id));
PROC_GLOBAL (void , CHK_DeallocateXTRA, (XTRAPntr xtra, char *id));

#endif /* CHECKGLU_H */

