/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * XMS.H
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 10/30/91
 *   MODIFIED : 10/06/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Public header file for XMS.C.
 *
 * HISTORY
 *		09/20/94 (dcc) - add support for __MSDOS32X__, __AMIGAOS__,
 *						 __MACOS__ and __EGGS_SGI__
 *
*/

#ifndef ECHIDNA_XMS_H
#define ECHIDNA_XMS_H

#include <echidna/platform.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <echidna/etypes.h>
#include <stddef.h>
/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/

typedef struct {
	UBYTE		 Type;
	UBYTE		 XMSWindow;
	UWORD		 Size;
	UWORD		 XMSHandle;
	ULONG		 XMSOffset;
} XMSPntr;

/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/

#define ActivateXMS(xp)	ActivateXMSatWin ((xp), 0)

/****************** F U N C T I O N   P R O T O T Y P E S *****************/

#if (__MSDOS32X__ || __AMIGAOS__ || __MACOS__ || __EGGS_SGI__)

extern	void	*__LastXTRA;

#define SetXMSMemoryPoolSize(cXMSKBytes)
#define SetMaxXMSWindows(maxwins)	
#define InitXMS(win)				
#define ActivateXMSatWin(xp,win)	(__LastXTRA = (void *)(xp))
#define	UpdateXMS(xp)				
#define ReleaseXMS(xp)				
#define FreeXMS						free
#define AllocXMS					malloc
#define	ReadXMS(xp,off,len,mem)		(memcpy((mem),((char *)(xp))+(off),(len)))
#define	WriteXMS(mem,len,xp,off)	(memcpy(((char *)(xp))+(off),(mem),(len)))
#define	AvailXMS(xmt)				(12345678L)
#define PopXMS()					
#define PushXMS()					

#elif __MSDOS__

extern void		 SetXMSMemoryPoolSize(UWORD cXMSKBytes);
extern void		 SetMaxXMSWindows (short maxwins);
extern short	 InitXMS (short windows);
extern void	far	*ActivateXMSatWin (XMSPntr *xp, short window);
extern void		 UpdateXMS (XMSPntr *xp);
extern void		 ReleaseXMS (XMSPntr *xp);
extern void		 FreeXMS (XMSPntr *xp);
extern XMSPntr	*AllocXMS (size_t size);
extern void		 ReadXMS (XMSPntr *xp, UWORD uwOffset, UWORD uwLength, void far *pMem);
extern void		 WriteXMS (void far *pMem, UWORD uwLength, XMSPntr *xp, UWORD uwOffset);
extern long		 AvailXMS(void);
extern void		 PopXMS (void);
extern short	 PushXMS (void);

#else
#error Need Macros
#endif

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_XMS_H */

