/*
 * DISKP.C
 *
 * PROGRAMMER : Dan Chang
 *    VERSION : 00.000
 *    CREATED : 10/12/93
 *   MODIFIED : 07/13/00
 *       TABS : 04 07
 *
 *	     \|///-_
 *	     \oO///_
 *	-----w/-w-----
 *	 E C H i D N A
 *	--------------
 *
 * DESCRIPTION
 *		getdisk() and setdisk() for MS-DOS Watcom C32.
 *
 * HISTORY
 *		10/12/93 (dcc) - Created.
 *		02/05/95 (dcc) - #include "diskp.h" to verify function prototypes.
 *
*/

#include <echidna/platform.h>

#if __MSDOS32X__

#include <dos.h>

#include "diskp.h"							// verify function prototypes

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/***************************** R O U T I N E S ****************************/


/*********************************************************************
 *
 * getdisk
 *
 * PURPOSE
 *		Gets the current drive number. Same as Borland C's getdisk().
 *
 * INPUT
 *		
 *
 * ASSUMES
 *		
 *
 * RETURN VALUE
 *		
 *
 * HISTORY
 *		10/12/93 Tuesday (dcc) - created.
 *
*/
int getdisk(void)
{
	union REGS regs;

	regs.x.eax = 0x1900;
	int386 (0x21, &regs, &regs);
	return regs.h.al;
} /* getdisk */


/*********************************************************************
 *
 * setdisk
 *
 * PURPOSE
 *		Set the current drive to <drive>. Same as Borland C's setdisk().
 *
 * INPUT
 *		
 *
 * ASSUMES
 *		
 *
 * RETURN VALUE
 *		
 *
 * HISTORY
 *		10/12/93 Tuesday (dcc) - created.
 *
*/
int setdisk(int drive)
{
	union REGS regs;

	regs.x.eax = 0x0E00;
	regs.x.edx = drive;
	int386 (0x21, &regs, &regs);
	return regs.h.al;
} /* setdisk */

#endif //__MSDOS32X__

