/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * TEST.C
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 09/10/90
 *   MODIFIED : 12/04/92
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Test the EUI library
 *
 * HISTORY
 *
*/

#include <echidna/platform.h>
#include "switches.h"

#include <echidna/grafx.h>
#include <echidna/fonts.h>
#include <echidna/eerrors.h>
#include <echidna/listfunc.h>
#include <echidna/memory.h>
#include <echidna/menus2.h>
#include <echidna/eui.h>
#include <echidna/windows.h>
#include <echidna/keyboard.h>
#include <echidna/mouse.h>
#include <echidna/readini.h>
#include <echidna/strings.h>
#include <echidna/lstgadg.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <io.h>

#include "colorseq.h"
#include "colorreq.h"
#include "system.h"
#include "euibpi.h"
#include "euidata.h"
#include "rm_tsinf.h"
#include "rmlst.h"
#include "tuglbl.h"

#define DS(msg)	\
	SetPenColor (255);						\
	DrawRect (10, 150, 25*8, 8);			\
 	DrawString (&MainFont, 10, 150, msg);



EasyFileReq		MainFr;

char *MainTitle   = ">> Title <<";
char *MainMessage = "Now is the time for all great men to come to the aid of their country.";
char *MainOptions = " TRUE | FALSE ";

extern void interrupt IgnoreErrors (void);

ColorInfo	*CurrentCI;

extern void TestMenus (void);

/*********************************************************************
 *
 * StackOverflow
 *
 * SYNOPSIS
 *		void StackOverflow (void)
 *
 * PURPOSE
 *		
 *
 * INPUT
 *
 *
 * EFFECTS
 *
 *
 * RETURN VALUE
 *
 *
 * HISTORY
 *
 *
 * SEE ALSO
 *
*/
void StackOverflow (void)
{
#if FUNC_NAMES
	puts (CurrentFuncName);
#endif
} /* StackOverflow */

/*********************************************************************
 *
 * SetColorReg
 *
 * SYNOPSIS
 *		void	SetColorReg (
 *			short regnum,
 *			short red,
 *			short green,
 *			short blue
 *		)
 *
 *
 * PURPOSE
 *		Set a single color register.
 *
 * INPUTS
 *		regnum:		0..15.
 *		red:		red value 0..64.
 *		green:		green value 0..64.
 *		blue:		blue value 0..64.
 *
*/
void LSetColorReg (
	short regnum,
	BYTE red,
	BYTE green,
	BYTE blue
)
{
#if 0
	inregs.h.ah = 0x10;
	inregs.h.al = 0x10;
	inregs.x.bx = regnum;
	inregs.h.ch = green;
	inregs.h.cl = blue;
	inregs.h.dh = red;

	int86(0x10, &inregs, &outregs);
#endif
#undef outp

	outp (0x03C8, regnum);
	outp (0x03C9, red);
	outp (0x03C9, green);
	outp (0x03C9, blue);
	
} /* SetColorReg */

TileSetType	TST;
RoomType	ROOM;

short		xmin = 0;
short		xmax = 320;
short		ymin = 0;
short		ymax = 200;

void main (int argc, char **argv)
{
	argc = argc;
	argv = argv;

	#if 0
	{
		IniList	*inilist

		inilist = ReadINI ("test.ini");
		if (inilist) {
			SectionTracker	 secx;
			SectionTracker	*sec = &secx;

			sec = FindSection (sec, inilist, "[KEYS]");
			if (sec) {
				ConfigLine	*cl;

				while ((cl = GetNextINILine (sec))) {
					printf ("'%s'\n", NodeName (cl));
				}
			}

			printf ("--------------------------------------------------\n");

			sec = FindSection (sec, inilist, "[MENUS]");
			if (sec) {
				ConfigLine	*cl;

				while ((cl = GetNextINILine (sec))) {
					printf ("'%s'\n", NodeName (cl));
				}
			}
		}
	}
	#endif

	#if 1
	if (argc == 4) {
		MainTitle = argv[1];
		MainMessage = argv[2];
		MainOptions = argv[3];
		
	}

	if (argc == 2) {
		SetDirSortType (atoi (argv[1]));
	}

	#if 0
	if (argc == 3) {
		ColorReqDivideX = atoi (argv[1]);
		ColorReqDivideY = atoi (argv[2]);
	}
	#endif

	if (argc == 3) {
		SetMouseResolution( atoi (argv[1]), atoi (argv[2]) );
	}
	if (argc == 7)
	{
		SetMouseResolution( atoi (argv[1]), atoi (argv[2]) );
		xmin = atoi (argv[3]);
		xmax = atoi (argv[4]);
		ymin = atoi (argv[5]);
		ymax = atoi (argv[6]);
		SetMouseRange ( xmin, xmax, ymin, ymax);
	}

	if (argc == 4) {
		ColorRange[0] = atoi (argv[1]);
		ColorRange[1] = atoi (argv[2]);
		ColorRange[2] = atoi (argv[3]);
		ColorMax[0] = ColorRange[0] - 1;
		ColorMax[1] = ColorRange[1] - 1;
		ColorMax[2] = ColorRange[2] - 1;
	}

	TST.Filespec = dupstr ("c:\\dpaint\\graphics\\work\\spot2\\tileset.lbm");

	InitFileReq (&MainFr);
	{
		IniList	*inilist;

		inilist = ReadINI ("test.ini");
		if (!inilist) {
			printf ("Error reading type lists\n");
			return;
		}
			
		#if 0
		if (!InitTypeLists (inilist)) {
			printf ("Error reading type lists\n");
			return;
		}
		#endif
		FreeINI (inilist);
	}
	if (OpenEUI ("test.ini")) {
		short		 i;
		short		 x;
		short		 y;

		CurrentCI = CreateColorInfo ();
		if (CurrentCI) {
			CS_Color	*colors;

			colors = ActivateXTRA (CurrentCI->pxtColors);

			{
				short	i;
				short	j;
				short	c;

				for (j = 0; j < 16; j++) {
					for (i = 0; i < 16; i++) {
						c = j * 16 + i;
						colors[c].Hue        = j ? ((j - 1) * 24) : 0;
						colors[c].Saturation = j ? (i * 8 + 64) : 0;
						colors[c].Value      = j ? (i * 12 + 64) : (i * 17);
						ConvertHSVtoRGB (&colors[c]);
					}
				}
			}
			colors[255].Red   = 137;
			colors[255].Green = 137;
			colors[255].Blue  = 137;
			ConvertRGBtoHSV (&colors[255]);
			colors[254].Red   = 0;
			colors[254].Green = 0;
			colors[254].Blue  = 0;
			ConvertRGBtoHSV (&colors[254]);

			SetGlobalColors(CurrentCI);

			#if 1
			if (OpenColorseqInterrupt ()) {
			#endif
				ComputeNextPalette (GlobalPalette, GlobalColors, TRUE);

				VBCycle = TRUE;

				BeforeGraphics ();
				SetWorkPage (DisplayBuffer);
				SetPaperColor (255);
				ClearWorkPage ();

				SetPenColor (6);
				DrawRect (0, 0, 320, 200);

				i = 0;
				for (y = 0; y < 16; y++) {
					for (x = 0; x < 16; x++) {
						SetPenColor (i);
						DrawRect (x * 8 + 50, y * 8 + 20, 8, 8);
						i++;
					}
				}

				#if 0

				DrawString (&MainFont, 10, 170, TileTypeGroup);
				DrawString (&MainFont, 10, 178, RoomTypeGroup);

				#endif

				AfterGraphics ();

				#if 0
				{
					short count = 0;
					short ascii = 0;

					while (ascii != 0x1B) {
						short	key;
						key = GetKeyNoWait ();
						if (key) {
							char	msg[100];

							count++;
							ascii = ConvertKeyToAscii (key);
							sprintf (msg, "count = %4d key = $%04x ascii = $%04x", count, key, ascii);
							SetPenColor (255);
							DrawRect (0, 150, 320, 8);
 							DrawString (&MainFont, 10, 150, msg);
						}
					}
				}
				#endif

				#if 0
				{
					short	x = xmin;
					short	y = ymin;
					short	xa = 1;
					short	ya = 1;

					while (!GetKeyNoWait())
					{
						EUICountDownTimer = 1;
						SetMousePosition (x, y);
						x += xa;
						if (x < xmin) {
							x  = xmin;
							xa = 1;
						}
						if (x >= xmax) {
							x  = xmax - 1;
							xa = -1;
						}
						y += ya;
						if (y < ymin) {
							y  = ymin;
							ya = 1;
						}
						if (y >= ymax) {
							y  = ymax - 1;
							ya = -1;
						}
						while (EUICountDownTimer);
					}					
				}
				#endif

				#if 1
				EUIMessageLoop ();
				#endif
				#if 1
				CloseColorseqInterrupt ();
			}
				#endif
		}

		CloseEUI ();
	}
	#endif

	if (GlobalErrMsg) {
		printf ("%s\n", GlobalErrMsg);
	}
}

void gprint (char *msg, short l) {
	l = l * 8;

	SetPenColor (255);
	DrawRect (0, l, 320, 8);
 	DrawString (&MainFont, 8, l, msg);
}

void About (void)
{
	char msg[2] = "0";

	msg[0] = '0' + Message (MainWindow, "Load How?",
						"What technique should I load these parts with?",
						" Without Borders \n|"
						" With Borders    \n|"
						" In a Grid       \n|"
						"0123\t\n|"
						"012345678901234567890123456789\t\n|"
						" In Grid w/stop  \n|"
						" Cancel \n");
/*	msg[0] = '0' + Message (MainWindow, MainTitle, MainMessage, MainOptions);
*/
	DS (msg);
}

void SMap1 (void)
{
	char	*filename;

	filename = GetFileName (MainWindow, &MainFr);
	if (filename) {
		DS (filename);
	} else {
		DS ("cancel selected");
	}
}

void	SelectFunc (void *pvdata, UWORD fWhy) {
	LGAD *plgad = pvdata;
	NOD	*pnod = pnodLGADFirstSelected (plgad);

	if (fWhy & LGAD_DOUBLE_CLICK) {
		while (pnod) {
			NOD *pnodNext = pnodLGADNextSelected (pnod);
			Remove (pnod);
			pnod = pnodNext;
		}
		SetLGADList (plgad, plgad->E.plst, plgad->E.cxMax);
	};
}

extern void DrawLine (short OLDX, short OLDY, short NEWX, short NEWY);

short NMap (void)
{
#define inodMax	20
#define cxszMax	180
#define	IntArgs0	55	/* x */
#define	IntArgs1	50	/* y */
#define	IntArgs2	125	/* w */
#define	IntArgs3	100	/* h */
#define	IntArgs4	12	/* width of elevator */
#define	IntArgs5	20	/* Speed of H Elevator */
#define	IntArgs6	20	/* Speed of V Elevator */
#define	IntArgs7	0	/* Exclusive or not */

	MouseInfo	mi;
	LGAD lgad;
	LST	lst;
	NOD nod[inodMax];
	static char *Names[inodMax] = {
		"Alvarado, Juan M., Programmer",
		"Baboon","Cougar","Dolphin","Elephant",
		"Fox","Giraffe","Hippopotomus",
		"Iguana","Jackal","Kangaroo","Lemur","Mandril",
		"Narwal","Ostrich","Penguin",
		"Quetzal","Racoon","Stegosaurus","Tarantula",
	};
	short i;

	memset(nod, 0, sizeof (NOD) * inodMax);
	InitList (&lst);
	for (i = 0; i < inodMax; i++) {
		nod[i].Name = Names[i];
		AddTail (&lst, &nod[i]);
	}
	if (InitTextLGAD (&lgad, 
		IntArgs2, IntArgs3, 
		&lst,
		LGAD_V_ELEVATOR | LGAD_V_REALTIME_SLIDER |
		LGAD_H_ELEVATOR | LGAD_H_REALTIME_SLIDER |
			((IntArgs7) ? 0 : LGAD_EXCLUSIVE), 
		IntArgs4,
		IntArgs5, IntArgs6,	/* horizontal and vertical arrow delay until repeat */
		cxszMax,
		SelectFunc,
		&lgad
		))
	{
		
		DrawLGAD (&lgad, IntArgs0, IntArgs1);

		while (!ExitProgram) {
			ReadMouse (&mi);
			
			if (mi.Buttons & MOUSE_LEFTBUTTON) {
				CheckHitAreas (phaLGAD(&lgad), IntArgs0, IntArgs1);
			}
			if (KeyWaiting ()) {
				short key = GetKey ();
				if (key) {
					CheckKeyHitAreas (phaLGAD(&lgad), key);
				}
			}
			HandleKeys (MainWindow);
		}
	}

	#if 0
	short	i;
	short	x1, x2, y1, y2, c;
	for (i = 0; i < 100; i++) {
		
		c  = random(256);
		x1 = random(320);
		x2 = random(320);
		y1 = random(200);
		y2 = random(200);
		SetPenColor (c);
		DrawLine (x1, y1, x2, y2);
	}
	#endif
	return TRUE;
}

void SetTheColors (void) {
	ColorSequencer (MainWindow, CurrentCI);
};


void ToggleCycleColors (void) {
	CurrentCI->CycleFlag = !CurrentCI->CycleFlag;	
}

void tumeInfo (void)
{
	#if 0
	RoomNTileInfoReq (NULL, &TST, TRUE);
	RoomNTileInfoReq (NULL, &TST, FALSE);
	RoomNTileInfoReq (&ROOM, NULL, TRUE);
	RoomNTileInfoReq (&ROOM, NULL, FALSE);
	#endif
}

void Undo (void)
{
	#if 0
	static	short flag;
	static 	ListType	rlistx;
	static	ListType	*rlist = &rlistx;
	static	RoomType	*croom;

	static	char *rnames[] = {
		"ClearMap",
		"LoadMap",
		"AppendMap",
		"SaveMap",
		"ZaveMap",
		"tumeInfo",
		"EditRoom",
		"DrawRandom",
		"ToggleTitleBar",
		"About",
		"Quit",
		"QuitAndExit",
		"LoadTilesFullTil",
		"LoadTilesFullTil",
		"LoadTilesCookieC",
		"LoadTilesBoxed",
		"SelectBlock",
		"SelectSquare",
		"CreateRoom",
		"DeleteRoom",
		"LoadRoom",
		"SaveRoom",
		"SaveRoomAll",
		"ClearRoom",
		"ClearRoom2",
		"ClearRoom3",
		"WCreate",
		"WClose",
		"PreviousRoom",
		"NextRoom",
		"FlipPanes",
		"WLockToSource",
		"WLockToEdit",
		"WLockToSame",
		"WLockClear",
		"SpaceToggle",
		NULL,
	};

	if (!flag) {
		RoomType	*rt;
		char		**sptr;

		flag = TRUE;
		InitList (rlist);

		sptr = rnames;
		while (*sptr) {
			rt = CreateNode (sizeof (RoomType), NULL);
			croom = rt;
			rt->Name = dupstr (*sptr);
			AddTail (rlist, rt);
			sptr++;
		}
	}

	croom = RoomListReq (rlist, croom);
	#endif

}

