/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * WINDOWS.C
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 10/22/90
 *   MODIFIED : 07/27/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Window Routines?
 *
 * HISTORY
 *
*/

#include <echidna/platform.h>
#include "switches.h"

#include <echidna/eerrors.h>
#include <echidna/windows.h>
#include <echidna/grafx.h>
#include <echidna/mouse.h>

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/***************************** R O U T I N E S ****************************/


/*********************************************************************
 *
 * DoWindowEvents
 *
 * SYNOPSIS
 *		DoWindowEvents (Window *window)
 *
 * PURPOSE
 *		
 *
 * INPUT
 *
 *
 * EFFECTS
 *
 *
 * RETURN VALUE
 *
 *
 * HISTORY
 *
 *
 * SEE ALSO
 *
*/
void DoWindowEvents (Window *window)
{

/*-------------------------------------------------------------------------*/
#if FUNC_NAMES
 CurrentFuncName = "DoWindowEvents";
#endif
#if REQUIRE

#endif
/*-------------------------------------------------------------------------*/

	{
		HitArea		*ha;
		Requester	*req;
		short		 xoff;
		short		 yoff;

		req = window->Req;
		if (req) {
			while (req->NextReq) {
				req = req->NextReq;
			}
			ha   = req->HitAreas;
			xoff = req->X;
			yoff = req->Y;
		} else {
			ha   = window->HitAreas;
			xoff = window->X;
			yoff = window->Y;
		}

		CheckHitAreas (ha, xoff, yoff);
	}

} /* DoWindowEvents */

/*********************************************************************
 *
 * PushWindowClipValues
 *
 * SYNOPSIS
 *		short PushWindowClipValues (Window *win)
 *
 * PURPOSE
 *		
 *
 * INPUT
 *
 *
 * EFFECTS
 *
 *
 * RETURN VALUE
 *
 *
 * HISTORY
 *
 *
 * SEE ALSO
 *
*/
short PushWindowClipValues (Window *win)
{

/*-------------------------------------------------------------------------*/
#if FUNC_NAMES
 CurrentFuncName = "PushWindowClipValues";
#endif
#if REQUIRE

#endif
/*-------------------------------------------------------------------------*/

	return PushClipValues (win->X, win->Y, win->Width, win->Height);

} /* PushWindowClipValues */

