/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * BLITTER.h
 *
 *    VERSION : 00.000
 *    CREATED : 08/25/89 
 *   MODIFIED : 08/25/89 
 *
 * DESCRIPTION
 *
 *
 * HISTORY
 *
*/
#ifndef BLITTER_H 
#define BLITTER_H 

#include <echidna/picture.h>

#define FastDrawShape(rp,shape,x,y)	\
	CopyMaskBitMap (&ShapePic(shape)->BitMap,0,0,\
			((struct RastPort *)(rp))->BitMap,x,y,\
			ShapeWidth(shape),ShapeHeight(shape),0xFF,\
			shape->MaskBm.Planes[0])

#define FastRectCopy(frp,fx,fy,trp,tx,ty,w,h)	\
	CopyBitMap (frp->BitMap,fx,fy,trp->BitMap,tx,ty,w,h,0xFF)

#if __STDC__

extern void		CopyBitMap ();
extern void		CopyMaskBitMap ();

#else

extern void		CopyBitMap (
				struct BitMap	*frombm,
				int		 fromleft,
				int		 fromtop,
				struct BitMap	*tobm,
				int		 toleft,
				int		 totop,
				int		 inwidth,
				int		 inheight,
				UBYTE		 planemask,
			);

extern void		CopyMaskBitMap (
				struct BitMap	*frombm,
				int		 fromleft,
				int		 fromtop,
				struct BitMap	*tobm,
				int		 toleft,
				int		 totop,
				int		 inwidth,
				int		 inheight,
				UBYTE		 planemask,
				UBYTE		*mask,
			);

#endif

#endif /* BLITTER_H */

