;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** ECLEAR.asm
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 03/05/90
;**   MODIFIED : 09/14/90
;**       TABS : 10 18 40 44
;**
;**	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**	Routine to clear the entire screen with current color.
;**
;** HISTORY
;**
;**
	IDEAL

;=====================================================================
;**
;** _EGA_ClearScreen
;** EGA_ClearScreen
;**
;** PURPOSE
;**	Clear an EGA screen with curren PaperColor.
;**
;** INPUT
;**	PaperColor = color to clear with.
;**	GrSeq      = SEGMENT of Screen to clear
;**
;** REGISTER USED
;**	AX, CX, ES, DI
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
PLines	DB	0

	MPROC	_EGA_ClearScreen
	MPROC	EGA_ClearScreen

	push	di

			;
			; ax -> es:di
			;
	cld		; Set Direction to Forward
	sub	di,di	; Clear DI
	mov	ax,[CS:EGrSeg]	; Get Segment of working buffer.
	mov	es,ax	;

	xor	bh,bh
	mov	bl,[CS:EPaperColor]	; Get Paper Color.

	mov	dx,03C4h	; write to all planes
	mov	ax,0F02h
	out	dx,ax

	mov	dx,03CEh
	mov	ax,0005h	; Select EGA RMD 0/WMD 0
	out	dx,ax

	mov	ax,0F01h	; Set Enable Set/Reset
	out	dx,ax 

;	mov	ax,0002h	; ???
;	out	dx,ax
;	mov	ax,0003h	; ???
;	out	dx,ax
;	mov	ax,0004h	; ???
;	out	dx,ax
;	mov	ax,0106h	; ???
;	out	dx,ax
;	mov	ax,0F07h	; ???
;	out	dx,ax

	mov	[CS:PLines],100	; 100 pairs of lines.
@@nextlines:

;
; Do Even Pixels on Even Line
;
	mov	ax,0AA08h	; Set EGA Mask to Even Pixels
	out	dx,ax

	mov	ah,[CS:_EGAEvenPatTbl+bx]	; Get Even/Even Pattern
	mov	cl,4
	shr	ah,cl
	mov	al,00h
	out	dx,ax	; Set Set/Reset to color.

	mov	cx,20
	rep stosw	; Write a line.

;
; Do Odd Pixels on Even Line
;
	sub	di,40	; Backup

	mov	ax,05508h	; Set EGA Mask to Odd Pixels
	out	dx,ax

	mov	ah,[CS:_EGAEvenPatTbl+bx]	; Get Even/Odd Pattern
	and	ah,0Fh
	mov	al,00h
	out	dx,ax	; Set Set/Reset to color.

	mov	cx,40
@@eloop:
	or	[es:di],al	; Write a line
	inc	di
	loop	@@eloop

;
; Do Even Pixels on Odd Line
;
	mov	ax,0AA08h	; Set EGA Mask to Even Pixels
	out	dx,ax

	mov	ah,[CS:_EGAOddPatTbl+bx]	; Get Odd/Even Pattern
	mov	cl,4
	shr	ah,cl
	mov	al,00h
	out	dx,ax	; Set Set/Reset to color.

	mov	cx,20
	rep stosw	; Write a line.

;
; Do Odd Pixels on Odd Line
;
	sub	di,40	; Backup

	mov	ax,05508h	; Set EGA Mask to Odd Pixels
	out	dx,ax

	mov	ah,[CS:_EGAOddPatTbl+bx]	; Get Odd/Odd Pattern
	and	ah,0Fh
	mov	al,00h
	out	dx,ax	; Set Set/Reset to color.

	mov	cx,40
@@oloop:
	or	[es:di],al	; Write a line
	inc	di
	loop	@@oloop
;
; Do next line pair
;
	dec	[CS:PLines]
	jg	@@nextlines

	pop	di

	ret

	ENDP
	ENDP

