;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 


; Modification of Dan Chang's translation of Juan Alvarado's C routine, by 
; Juan Alvarado.
;
	IDEAL

	PUBLIC	_EGA_ASM_WriteColors
	PUBLIC	_EGA_ActivationFlag
	PUBLIC	_EGAColors
	PUBLIC	_EGA_RetraceBegun

	EVEN

_EGA_RetraceBegun	dw	?		;Set to true upon entry.
_EGA_ActivationFlag	dw	?		;do work or not
_EGAColors		dd	?		;pointer to colors to copy.

; Table to convert pseudo EGA color UBYTES that have intensity flag 
; in bit 3 to real EGA color UBYTES with intensity flag in bit 4.
EGAClrCnvTbl	DB  0h, 1h, 2h, 3h, 4h, 5h, 6h, 7h
				DB 10h,11h,12h,13h,14h,15h,16h,17h

	MPROC _EGA_ASM_WriteColors

	cld
	mov cl, 1
	mov	[byte ptr cs:_EGA_RetraceBegun], cl	;= 1
	mov	ax, [cs:_EGA_ActivationFlag]
	or	ax, ax
	jz	@@OutDone		;=> nothing to do!

	push	ds
	push	si

	mov	dx, 3DAH	; CRT Color Display Status register
	in	al,	dx		; Read it to set flip-flop so next out through 3C0H
					; will write the Attribute Controller's index register.

	mov	dx, 3C0H	; Attribute controller I/O port.
	mov	cx, 16		; Will write 16 colors registers.

	lds	si, [cs:_EGAColors]	;-> 1st byte of data to write.
	mov	bx,	offset EGAClrCnvTbl	; Set up translation table.

	xor	ah,	ah		; First index (palette register) to load.

@@writeLoop:
	mov	al,	ah		; Fetch next index (palette register).
	out	dx,	al		; Select next index (palette register).
	lodsb			; Fetch next value from data table.
	xlat	[CS:EGAClrCnvTbl]	; Translate the value.
	out	dx, al		; Load palette register with translated value.
	inc	ah			; Update index.
	loop	@@writeLoop

;	mov al, 11H		; Overscan register 
;	out	dx, al		; Select for next write.
;	jmp	$+2			; wast a few cycles.
;	mov	al,	0		; black color.
;	out	dx,	al		; Write it to Overscan register.

	mov	al,	20H		; Must turn controller back ON.
	out	dx,	al		; Sets bit 5 of Attribute Controller's index register.

	mov	[cs:_EGA_ActivationFlag], cx	;= 0

	pop	si
	pop	ds
@@OutDone:
	ret
	ENDP

