# 
# The contents of this file are subject to the Mozilla Public 
# License Version 1.1 (the "License"); you may not use this file 
# except in compliance with the License. You may obtain a copy of 
# the License at http://www.mozilla.org/MPL/ 
# 
# Software distributed under the License is distributed on an "AS 
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
# implied. See the License for the specific language governing 
# rights and limitations under the License. 
# 
# The Original Code is tUME: the Universal Map Editor, released 
# June 18, 2000. 
# 
# The Initial Developer of the Original Code is Echidna. 
# Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
# All Rights Reserved. 
# 
# Contributor(s): 
# 

#
# Name of program.
#
PROGRAM   = test

#
# Program Modules.
#
PDEP =	\
		$(PROGRAM).obj	\
		graphics.obj	\
		dbuf.obj		\
		edraw.obj		\
		fonts.obj		\
		clip.obj		\
		line.obj		\
		tgfx.obj		\
		tsup.obj		\
		tpalette.obj	\
		tdbuf.obj		\
		cgfx.obj		\
		csup.obj		\
		cpalette.obj	\
		cdbuf.obj		\
		mgfx.obj		\
		msup.obj		\
		mpalette.obj	\
		mdbuf.obj		\
		egfx.obj		\
		esup.obj		\
		epalette.obj	\
		edbuf.obj		\

ODEP =	\

#
# Memory Model
#   s = Small
#   m = Medium
#   c = Compact
#   l = Large
#   h = Huge
MDL		= h
STARTUP	= c0$(MDL).obj

LDEP =	\
		echidna\xpak$(MDL).lib		\
		echidna\misc$(MDL).lib		\
		echidna\lds$(MDL).lib		\
		echidna\mem$(MDL).lib		\
		c$(MDL).lib
#
# Name of linker file
#
LINKFILE  = linkfile.lnk

#
# 'C' compiler and global compiler flags.
#
CCOMPILER = tcc
CFLAGS    = -O- -r- -G- -Z- -c -m$(MDL) -d -N -v -w -w-pia -wpro -wstv
#CCOMPILER = tsc
#CFLAGS    = -m$(MDL)

#
# Assembler and global assembler flags.
#
ASSEMBLER = tasm
#AFLAGS    = /mx
AFLAGS    = /mx /zi

#
# Yacc and global yacc flags.
#
YACC      = D:\PCYACC\PCYACC
YFLAGS    = -d -t

#
# Linker and global linker flags + libraries to like with.
#
LINKER    = tlink
LFLAGS    = /c /x /v /m
#LFLAGS    = /c /x
LIBFILE   = libs.lnk

#
# Rule for Assembly modules.
#
.asm.obj:
	$(ASSEMBLER) $(AFLAGS) $*.asm

#
# Rule for 'C' modules.
#
.c.obj:
	$(CCOMPILER) $(CFLAGS) $*.c

#
# Rule for 'Y' modules.
#
.y.c:
	$(YACC) $(YFLAGS) $*.y

#
# Dependency for program.
#
$(PROGRAM).exe: $(PDEP)
	makescan
	$(LINKER) $(LFLAGS) @$(LINKFILE), $(PROGRAM).EXE, , @$(LIBFILE)
	dir $(PROGRAM).EXE
#
# extra dependencies
#

