;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** MCLEAR.asm
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 12/15/89
;**   MODIFIED : 10/06/93
;**       TABS : 10 18 40 44
;**
;**	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**	Protected-mode routine to clear the entire screen with current color.
;**
;** HISTORY
;**
;**
	IDEAL

;=====================================================================
;**
;** void MCGA_ClearScreen(void);
;**
;** PURPOSE
;**	Clear an MCGA screen with curren PaperColor.
;**
;** INPUT
;**	PaperColor : color to clear with.
;**	MGrDraw    : address of Screen to clear
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**

	MPROC	MCGA_ClearScreen_
	MPROC	MCGA_ClearScreen

	BeforeGraphics

	push	ebp
	mov	ebp, esp

	push	eax
	push	ecx
	push	edi

	mov	edi, [MGrDraw]	; EDI = address to draw to

	if USE_GRAFX
	sub	ecx, ecx
	mov	cl, [MPaperColor]	; Get Paper Color.
	mov	al, [_RemapTable+ecx]	; Look up thru RemapTable
	else
	mov	al, [MPaperColor]	; Get Paper Color.
	inc	al	; Inc color up one.
	endif
	mov	ah, al	; put it in both halfs of AX
	mov	ecx, eax
	shl	eax, 16
	mov	ax, cx	; Pen color in all four bytes of EAX

	mov	ecx,(SCREEN_WIDTH * SCREEN_HEIGHT / 4)	; Set Length to full screen.
	cld		; Set direction to Forward.

	push	es

	push	ds
	pop	es	;ES = DS

	rep stosd	; Do the fill;

	pop	es

	pop	edi
	pop	ecx
	pop	eax

	pop	ebp
	AfterGraphics

	ret

	ENDP
	ENDP

