;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 


; Modification of Dan Chang's translation of Juan Alvarado's C routine, by 
; Juan Alvarado.
;
	IDEAL

	PUBLIC	_TGA_ASM_WriteColors
	PUBLIC	_TGA_ActivationFlag
	PUBLIC	_TGAColors
	PUBLIC	_TGA_RetraceBegun

	EVEN

_TGA_RetraceBegun	dw	?		;Set to true upon entry.
_TGA_ActivationFlag	dw	?		;do work or not
_TGAColors		dd	?		;pointer to colors to copy.

	MPROC _TGA_ASM_WriteColors

	mov cl, 1
	mov	[byte ptr cs:_TGA_RetraceBegun], cl	;= 1
	mov	ax, [cs:_TGA_ActivationFlag]
	or	ax, ax
	jz	@@OutDone		;=> nothing to do!

	push	ds
	push	si

	mov	cx, 16		; Will write 16 colors registers.

	lds	si, [cs:_TGAColors]	;-> 1st byte of data to write.

	xor	ah,	ah		; First index (palette register) to load.

	cld
@@writeLoop:
	mov	dx,	03DAH	; 
	mov	al,	ah		; Fetch next index (palette register).
	out	dx,	al		; Select next index (palette register).
	inc	ah			; Update index.

	mov	dx,03DEh	; ? copied this instruction from _TGA_ASMSetPalette.
	lodsb			; Fetch next value from data table.
	out	dx, al		; Load palette register with translated value.
	loop	@@writeLoop

	mov	[cs:_TGA_ActivationFlag], cx	;= 0

	pop	si
	pop	ds
@@OutDone:
	ret
	ENDP

