;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** IBMERRP.ASM
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 04/28/90
;**   MODIFIED : 10/13/93
;**       TABS : 10 18 40 44
;**
;**	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**	IBM Critical Error Header?
;**
;** HISTORY
;**	10/12/93 Tuesday (dcc) - updated to support MS-DOS Watcom C32
;**
	.386

	IDEAL

;**************************** GLOBAL VARIABLES *****************************
	PUBLIC	_ErrReturnCode
	PUBLIC	_SysErrorFunc

;******************************** ROUTINES *********************************

	PUBLIC	IBMErrIntHeader_
	PUBLIC	IgnoreErrors_
	PUBLIC	GetSysErrorVector_
	PUBLIC	SetSysErrorVector_

	; "User modifiable" constants

STACKSIZE	equ	512

	SEGMENT _DATA DWORD PUBLIC USE32 'DATA'

	ALIGN	4
InterruptStack	dd	(STACKSIZE/4) dup (?)

_SysErrorFunc	DD ?
_ErrReturnCode	DW ?
	ENDS	_DATA

	GROUP	DGROUP _DATA

	SEGMENT _TEXT DWORD PUBLIC USE32 'CODE'

	ASSUME	cs:_TEXT
	ASSUME	ds:DGROUP

;=====================================================================
;**
;** IBMErrIntHeader_
;**
;** PURPOSE
;**	
;**
;** INPUT
;**	
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**

	PROC IBMErrIntHeader_
	
	push	ebx	; save registers
	push	ecx
	push	edx
	push	ebp
	push	esi
	push	edi

	push	ds
	push	es

	sti

	mov	ax, DGROUP
	mov	ds, ax
	mov	es, ax

	; Switch to our stack:

	mov	bx, ss
	mov	ecx, esp
	mov	ss, ax
	lea	esp, [InterruptStack+STACKSIZE]
	push	ebx			;old SS
	push	ecx			;old ESP

	call	[_SysErrorFunc]

	; Switch back to interrupt stack:

	pop	ebx			;old ESP
	pop	eax			;old SS
	mov	ss, ax
	mov	esp, ebx

	mov	ax, [_ErrReturnCode]

	pop	es
	pop	ds

	pop	edi
	pop	esi
	pop	ebp
	pop	edx
	pop	ecx
	pop	ebx

	iretd

	ENDP


;=====================================================================
;**
;** IgnoreErrors_
;**
;** PURPOSE
;**	Interrupt stub to "fail" dos errors.
;**
;** INPUT
;**	
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	PROC	IgnoreErrors_

	sub	eax, eax
	mov	[_ErrReturnCode], ax
	ret

	ENDP


;=====================================================================
;**
;**	INT far32 *GetSysErrorVector(void)
;**
;** PURPOSE
;**	Return current MS-DOS critical error handler vector.
;**
;** INPUT
;**	
;**
;** ASSUMES
;**	
;**
;** REGISTER USED
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	10/12/93 Tuesday (dcc) - created.
;**

	PROC	GetSysErrorVector_

	push	ebx
	push	ds
	push	es

	mov	eax, 3524h
	int	21h
	mov	eax, ebx

	pop	es
	pop	ds
	pop	ebx
	ret

	ENDP


;=====================================================================
;**
;**	void SetSysErrorVector(INT far32 *pInt)
;**
;** PURPOSE
;**	Set MS-DOS critical error handler vector.
;**
;** INPUT
;**	
;**
;** ASSUMES
;**	
;**
;** REGISTER USED
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	10/12/93 Tuesday (dcc) - created.
;**

	PROC	SetSysErrorVector_

	push	eax
	push	edx
	push	ds
	push	es

	sub	dx, dx
	mov	es, dx
	mov	dx, cs
	mov	ds, dx
	mov	edx, eax
	mov	eax, 2524h
	int	21h

	pop	es
	pop	ds
	pop	edx
	pop	eax
	ret

	ENDP
	ENDS

	END

