/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * ATIMLIST.C
 *
 * PROGRAMMER : R.G. Marquez 
 *    VERSION : 00.000
 *    CREATED : 06/23/91 
 *   MODIFIED : 07/27/94
 *       TABS : 04 09
 *
 *	     \|///-_
 *	     \oO///_
 *	-----w/-w-----
 *	 E C H i D N A
 *	--------------
 *
 * DESCRIPTION
 *		Macro list routines for Amiga timer library.  These are a try at
 *	speed for the interrupt dependent routines.  If the LDS.lib list
 *	routines are fast enough for interrupt proccessing, we should prolly
 *	use them instead.
 *
 * HISTORY
 *	06/23/91 Sunday (RGM) - Created.
 *
*/
#include <echidna/platform.h>
#include "switches.h"

#include "atimlist.h"

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/


/****************************** E X T E R N S *****************************/


/****************************** G L O B A L S *****************************/


/******************************* L O C A L S ******************************/


/******************************* M A C R O S ******************************/


/***************************** R O U T I N E S ****************************/

void __far * __far __regargs ate_RemHead(void __far *list_ptr)
{
	register ATimer_MinNode	__far *node_ptr;

	node_ptr	= ate_Head(list_ptr);
	if (! ate_IsTail(node_ptr)) {
		ate_Remove (node_ptr);
	}
	else {
		node_ptr	= NULL;
	}

	return (void __far *) node_ptr;
}

void __far * __far __regargs ate_RemTail(void __far *list_ptr)
{
	register ATimer_MinNode	__far *node_ptr;

	node_ptr	= ate_Tail(list_ptr);
	if (! ate_IsHead(node_ptr)) {
		ate_Remove (node_ptr);
	}
	else {
		node_ptr	= NULL;
	}

	return (void __far *) node_ptr;
}

